unit fInfoBoxWithBtnControl;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls,
  VA508AccessibilityManager;

type
  TfrmInfoBoxWithBtnControl = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    GridPanel1: TGridPanel;
    lblText: TVA508StaticText;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;

    procedure btnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    value: integer;
    procedure setControl(var btn: TButton; text: string; show: boolean; index: integer = 0);
    procedure sizePanel;
  public
    { Public declarations }
  end;

function processMessage(caption, text: string; buttons: TStringList): integer;

var
  frmInfoBoxWithBtnControl: TfrmInfoBoxWithBtnControl;

implementation

uses ORFn;

{$R *.dfm}
function processMessage(caption, text: string; buttons: TStringList): integer;
var
cnt, colcnt, i, num: integer;
percent: double;
str: string;
btn: TButton;
begin
  result := -1;
  try
    begin
      frmInfoBoxWithBtnControl := TfrmInfoBoxWithBtnControl.Create(Application);
      ResizeAnchoredFormToFont(frmInfoBoxWithBtnControl);
      frmInfoBoxWithBtnControl.value := -1;
      frmInfoBoxWithBtnControl.Caption := caption;
      frmInfoBoxWithBtnControl.lblText.Caption := text;
      frmInfoBoxWithBtnControl.sizePanel;
      cnt := buttons.Count;
      case cnt of
        4:
        begin
          str := buttons.Strings[0];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button1, str, true, 0);
          str := buttons.Strings[1];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button2, str, true, 1);
          str := buttons.Strings[2];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button3, str, true, 2);
          str := buttons.Strings[3];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button4, str, true, 3);
        end;
        3:
        begin
          str := buttons.Strings[0];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button1, str, true, 0);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[0].Value := 33.00;
          str := buttons.Strings[1];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button2, str, true, 1);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[1].Value :=33.00;
          str := buttons.Strings[2];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button3, str, true, 2);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[2].Value := 33.00;
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button4, '', false);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[3].Value := 0;
        end;
        2:
        begin
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button1, '', false);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[0].Value := 0;
          str := buttons.Strings[0];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button2, str, true, 0);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[1].Value := 50.00;
          str := buttons.Strings[1];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button3, str, true, 1);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[2].Value := 50.00;
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button4, '', false);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[3].Value := 0;
        end;
        1:
        begin
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button1, '', false);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[0].Value := 0;
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button2, '', false);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[1].Value := 0;
          str := buttons.Strings[0];
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button3, str, true, 0);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[2].Value := 100;
          frmInfoBoxWithBtnControl.setControl(frmInfoBoxWithBtnControl.Button4, '', false);
          frmInfoBoxWithBtnCOntrol.GridPanel1.ColumnCollection[3].Value := 0;
        end;
      end;
      frmInfoBoxWithBtnControl.GridPanel1.Refresh;
      if frmInfoBoxWithBtnControl.ShowModal > -1 then
        begin
          result := frmInfoBoxWithBtnControl.value;
        end;
    end;
  finally

  end;

end;

{ TfrmInfoBoxWithBtnControl }



procedure TfrmInfoBoxWithBtnControl.btnClick(Sender: TObject);
var
btn: TButton;
begin
    btn := Sender as TButton;
    if btn.Tag < 0 then modalResult := -1
    else
      begin
        modalResult := btn.Tag;
        frmInfoBoxWithBtnControl.value := btn.tag;
//        frmInfoBoxWithBtnControl.CloseModal;
        close;
      end;
end;

procedure TfrmInfoBoxWithBtnControl.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    try
    inherited;
    Action := caFree;
  except
    Action := caFree;
  end;
end;

procedure TfrmInfoBoxWithBtnControl.setControl(var btn:TButton; text: string; show: boolean; index: integer);
begin
  if show = false then
          begin
            btn.Visible := false;
            btn.Enabled := false;
          end
        else
          begin
            btn.Caption := text;
            btn.Width := TextWidthByFont(btn.Handle, btn.Caption) + 5;
            btn.Height := TextHeightByFont(btn.Handle, btn.Caption) + 10;
            btn.Tag := index;
          end;
end;

procedure TfrmInfoBoxWithBtnControl.sizePanel;
var
 height, width: integer;
begin
    //self.lblText.Width :=  TextWidthByFont(self.lblText.Handle, self.lblText.Caption) + 5;
    //self.lblText.Height :=  TextWidthByFont(self.lblText.Handle, self.lblText.Caption) + 10;
    self.Panel1.Width := self.lblText.Left + self.lblText.Width + 5;
    self.Panel1.Height := self.lblText.Top + self.lblText.Height + 5;
//    self.Height := self.GridPanel1.Top + self.GridPanel1.Height;
end;

end.
